﻿function Perm<T>(a: array of T): array of T; // p07008
begin
  Result := Copy(a);
  for var i := 0 to a.Length div 2 - 1 do
    Swap(Result[2 * i], Result[2 * i + 1]);
end;

begin
  var a := ArrRandom(9, 10, 99);
  a.Println; // 45 99 38 67 72 87 83 12 56
  var b := Perm(a);
  b.Println; // 99 45 67 38 87 72 12 83 56
  var c := SeqRandomReal(8, 10, 99).Select(p -> Round(p, 1)).ToArray;
  c.Println;       // 97.3 96.8 98.3 29.5 44.9 12 43.7 37.9
  Perm(c).Println; // 96.8 97.3 29.5 98.3 12 44.9 37.9 43.7
end.