﻿library p11014;

interface

type
  /// Точка на плоскости
  TPoint = record
    x: real;
    y: real
  end;
  
  /// Линия на плоскости
  TLine = record
    A: TPoint;
    B: TPoint
  end;
  
  /// Треугольник на плоскости
  TTriangle = record
    a: TLine;
    b: TLine;
    c: TLine
  end;

/// Возвращает точку с заданными координатами х и у
function СоздатьТочку(x, y: real): TPoint;
/// Возвращает линию, заданную парой точек Pa и Pb
function СоздатьЛинию(Pa, Pb: TPoint): TLine;
/// Возвращает треугольник, заданный сторонами a, b, c
function СоздатьТреугольник(a, b, c: TLine): TTriangle;

implementation

function СоздатьТочку(x, y: real): TPoint;
begin
  (Result.x, Result.y) := (x, y);
end;

function СоздатьЛинию(Pa, Pb: TPoint): TLine;
begin
  (Result.A, Result.B) := (Pa, Pb);
end;

function СоздатьТреугольник(a, b, c: TLine): TTriangle;
begin
  (Result.a, Result.b, Result.c) := (a, b, c)
end;

end.