﻿// p13010
type
  Дробь = class
  public 
    Числитель: integer;
    Знаменатель := 1;

    constructor(Чис, Знам: integer) :=
        (Числитель, Знаменатель) := (Чис, Знам);
  
    constructor(Чис: integer) := Числитель := Чис;
    
    static function operator -(a: Дробь) :=
        new Дробь(-a.Числитель, a.Знаменатель);
    
    static function operator +(a, b: Дробь) := 
        new Дробь(a.Числитель * b.Знаменатель +
          b.Числитель * a.Знаменатель,
          a.Знаменатель * b.Знаменатель);
          
    static function operator -(a, b: Дробь) := 
        new Дробь(a.Числитель * b.Знаменатель -
          b.Числитель * a.Знаменатель,
          a.Знаменатель * b.Знаменатель);      

    static function operator *(a, b: Дробь) :=
        new Дробь(a.Числитель * b.Числитель,
            a.Знаменатель * b.Знаменатель);
    
    static function operator /(a, b: Дробь) :=
        new Дробь(a.Числитель * b.Знаменатель,
            b.Числитель * a.Знаменатель);

    function ToString: string; override :=
        $'{Числитель}/{Знаменатель}';
        
    static function operator explicit
        (a:(integer, integer)): Дробь :=
        new Дробь(a[0], a[1]);
    
    static procedure operator += (var a: Дробь; b: Дробь) :=
        a := a + b;
  
end;

begin
  var a := Дробь((3, 4));
  var b := new Дробь(-2, 5);
  var c := (a + b) / (a - b);
  c += a * b;
  Writeln(c) // 40/9200
end.