﻿// p13033
type
  Выпускники = class
  private
    ФамилияИО: string;
    ГодВыпуска: integer;
    СрБалл: real;
  public
    constructor(Фам: string; Год: integer; Балл: real) :=
        (ФамилияИО, ГодВыпуска, СрБалл) := (Фам, Год, Балл);
    property Фамилия: string read ФамилияИО; virtual;
    property Выпуск: integer read ГодВыпуска; virtual;
    property СреднийБалл: real read СрБалл; virtual;
  end;
  
  СортироватьПоФамилии = class(IComparer<Выпускники>)
  public
    function Compare(a, b: Выпускники): integer;
    begin
      if a.ФамилияИО < b.ФамилияИО then
        Result := -1
      else
        if a.ФамилияИО > b.ФамилияИО then
          Result := 1
        else
          Result := 0
    end;
  end;
  
  СортироватьПоБаллу = class(IComparer<Выпускники>)
  public
    function Compare(a, b: Выпускники) :=
        -Sign(a.СрБалл - b.СрБалл);
  end;
  
  СортироватьПоГоду = class(IComparer<Выпускники>)
  public
    function Compare(a, b: Выпускники) :=
        Sign(a.ГодВыпуска - b.ГодВыпуска);
  end;
  
begin
  var НашиВыпускники := new List<Выпускники>;
  НашиВыпускники.Add(new Выпускники('Смирнов А.И.',2010, 4.27));
  НашиВыпускники.Add(new Выпускники('Петров К.В.',2012, 3.72));
  НашиВыпускники.Add(new Выпускники('Тарасова Г.А.',2010, 4.6));
  НашиВыпускники.Add(new Выпускники('Попова И.Ф.',2008, 4.47));
  НашиВыпускники.Add(new Выпускники('Смирнов А.И.',2008, 4.25));
  НашиВыпускники.Add(new Выпускники('Смирнов А.И.',2010, 4.73));
  Println('По фамилиям:');
  НашиВыпускники.Sort(new СортироватьПоФамилии);
  НашиВыпускники.PrintLines;
  Println('По убыванию среднего балла:');
  НашиВыпускники.Sort(new СортироватьПоБаллу);
  НашиВыпускники.PrintLines;
  Println('По году выпуска:');
  НашиВыпускники.Sort(new СортироватьПоГоду);
  НашиВыпускники.PrintLines;
end.