﻿// p13034
type
  Obj = class(System.ICloneable)
  public 
    constructor(px, py, pz: integer; pa: array of integer);
    begin
      (x, y, z) := (px, py, pz);
      a := Copy(pa);
    end;
    
    function MyClone: Obj; // поверхностное клонирование
    begin
      Result := Obj(Self.MemberwiseClone);
      // Result.a := Copy(Self.a) специально !!!
    end;
    
    function Clone: object;
    begin
      Result := Obj(Self.MemberwiseClone);
      Obj(Result).a := Copy(Self.a)
    end;
    
    auto property x: integer;
    auto property y: integer;
    auto property z: integer;
    auto property a: array of integer;
  end;

procedure PrinrObj(msg: string; pO: Obj);
begin
  Write($'{msg}: x={pO.x}, y={pO.y}, z={pO.z}, a=[');
  pO.a.Print;
  Writeln(']')
end;

procedure Test(E: Obj; var A, B: Obj; msg: string; P: Obj-> Obj);
begin
  A := Obj(E.Clone);
  Println(msg);
  PrinrObj('Эталон', E);
  B := P(A);
  (B.y, B.a[2]) := (8, 9);
  PrinrObj('OA    ', A);
  PrinrObj('OB    ', B);
end;

begin
  var oE := new Obj(1, 2, 3, Arr(4, 5, 6, 7)); // эталон
  var oA, oB: Obj;
  Test(oE, oA, oB, 'Копирование', t -> t);
  Test(oE, oA, oB, 'Поверхностное клонирование', t -> t.MyClone);
  Test(oE, oA, oB, 'Глубокое клонирование', t -> Obj(t.Clone));
end.