﻿type
  tRoot = abstract class
    function GetRoots: array of real; abstract;
    procedure OutRoots(t: array of real); abstract;
  end;
  
  tLinear = class(tRoot)
    private
      coef: array of real;
    public
      constructor(coef: array of real);
      begin
        if coef.Length = 2 then
          Self.coef := coef;
      end;

      function GetRoots: array of real; override;
      begin
        if coef <> nil then
          Result := Arr(-coef[1]/coef[0])
        else
          Result := nil
      end;
      
      procedure OutRoots(a: array of real); override;
      begin
        if a <> nil then
        begin  
          var s := $'Корень уравнения {coef[0]}x ';
          if coef[1]> 0 then
            s += $'+ {coef[1]} = 0'
          else
            if coef[1] = 0 then
              s+= '= 0'
            else
              s += $'- {-coef[1]} = 0';
          s += $' равен {a[0]}';
          Println(s)
        end
        else
          Println('Неверно заданы коэффицианты уравнения')
      end;
  end;
  
  tSquare = class(tRoot)
    private
      coef: array of real;
    public
      constructor(coef: array of real);
      begin
        if coef.Length = 3 then
          Self.coef := coef;
      end;

      function GetRoots: array of real; override;
      begin
        if coef <> nil then
        begin
          var D := Sqrt(Sqr(coef[1]) - 4*coef[0]*coef[2]);
          Result := Arr((-coef[1]-D)/2/coef[0], (-coef[1]+D)/2/coef[0])
        end
        else
          Result := nil
      end;
      
      procedure OutRoots(a: array of real); override;
      begin
        if a <> nil then
        begin  
          var s := $'Корни уравнения {coef[0]}x^2 ';
          if coef[1]> 0 then
            s += $'+ {coef[1]}x '
          else
            if coef[1] < 0 then
              s += $'- {-coef[1]}x ';
          if coef[2]> 0 then
            s += $'+ {coef[2]} = 0'
          else
            if coef[2] < 0 then
              s += $'- {-coef[2]} = 0';    
          s += $' равны {a[0]}, {a[1]}';
          Println(s)
        end
        else
          Println('Неверно заданы коэффицианты уравнения')
      end;
  end;

begin
  var obj := new tLinear(Arr(1.2, 3.6));
  var a := obj.GetRoots;
  obj.OutRoots(a);
  var obj1 := new tSquare(Arr(2.0, -7.0, -15.0));
  a := obj1.GetRoots;
  obj1.OutRoots(a)
end.